package main;

import java.awt.Color;
import java.awt.image.BufferedImage;

public class BuscadorDeLinhaSelecionada {

	private Color corDaSelecao;

	private int margemSuperiorAdicionada; // valor em pixels
	private int margemInferiorAdicionada; // valor em pixels

	public BuscadorDeLinhaSelecionada(Color corDaSelecao, int margemSuperiorAdicionada, int margemInferiorAdicionada) {
		this.corDaSelecao = corDaSelecao;
		this.margemSuperiorAdicionada = margemSuperiorAdicionada;
		this.margemInferiorAdicionada = margemInferiorAdicionada;
	}

	public LinhaDaSelecao encontrarInicioEFimDaLinhaSelecionada(BufferedImage areaDaSelecaoScreenshot, int margemY) {
		LinhaDaSelecao linha = encontrarInicioEFim(areaDaSelecaoScreenshot, corDaSelecao, margemY);
		if (linha == null)
			return null;
		System.out.println("inicioY: " + linha.inicioY + " / linha.fimY: " + linha.fimY);
		linha.inicioY = linha.inicioY - margemSuperiorAdicionada;
		linha.fimY = linha.fimY + margemInferiorAdicionada;
		System.out.println("inicioY: " + linha.inicioY + " / linha.fimY: " + linha.fimY);
		return linha;
	}

	private LinhaDaSelecao encontrarInicioEFim(BufferedImage img, Color cor, int margemY) {
		boolean encontrou = false;
		LinhaDaSelecao linhaDaSelecao = new LinhaDaSelecao();
		linhaDaSelecao.inicioY = Integer.MAX_VALUE;
		linhaDaSelecao.fimY = Integer.MIN_VALUE;
		for (int x = 0; x < img.getWidth(); x++) {
			for (int y = 0; y < img.getHeight(); y++) {
				if (new Color(img.getRGB(x, y)).equals(corDaSelecao)) {
					int posicaoYRealDoPixel = y + margemY;
					if (linhaDaSelecao.inicioY > posicaoYRealDoPixel) {
						encontrou = true;
						linhaDaSelecao.inicioY = posicaoYRealDoPixel;
					}
					if (linhaDaSelecao.fimY < posicaoYRealDoPixel) {
						encontrou = true;
						linhaDaSelecao.fimY = posicaoYRealDoPixel;
					}
				}
			}
		}
		return (encontrou) ? linhaDaSelecao : null;
	}

	public static class LinhaDaSelecao {
		public int inicioY;
		public int fimY;
	}
}
