package main.listener;

import java.util.logging.Level;
import java.util.logging.LogManager;
import java.util.logging.Logger;

import org.jnativehook.GlobalScreen;
import org.jnativehook.NativeHookException;
import org.jnativehook.keyboard.NativeKeyListener;

public class ListenerDeEventosNativos {

	public static void iniciar() throws NativeHookException {
		removerLogDoJNativeHook();
		registrarONativeHook();
	}

	private static void registrarONativeHook() throws NativeHookException {
		try {
			GlobalScreen.registerNativeHook();

		} catch (NativeHookException ex) {
			System.err.println("There was a problem registering the native hook.");
			throw ex;
		}
	}

	private static void removerLogDoJNativeHook() {
		// Clear previous logging configurations.
		LogManager.getLogManager().reset();

		// Get the logger for "org.jnativehook" and set the level to off.
		Logger logger = Logger.getLogger(GlobalScreen.class.getPackage().getName());
		logger.setLevel(Level.OFF);
	}

	public static void addNativeKeyListener(NativeKeyListener listener) {
		// Construct the example object and initialze native hook.
		GlobalScreen.addNativeKeyListener(listener);
	}

}
